import sys
import socket
import SocketServer


PORT_NUMBER = int(sys.argv[1])
SERVER_ID = int(sys.argv[2])
APP_ID = int(sys.argv[3])
STR_APP_ID = 'application'
STR_APP_ID += str(APP_ID)

filename = 'output_'
filename += STR_APP_ID
filename += '_'
filename += str(SERVER_ID)
filename += '.txt'
# output = open(filename, 'w')

class myRequestHandler(SocketServer.BaseRequestHandler):
    
    def __init__(self, request, client_address, server):
        SocketServer.BaseRequestHandler.__init__(self, request, client_address, server)
        return

    def setup(self):
        return SocketServer.BaseRequestHandler.setup(self)

    def handle(self):
        output = open(filename, 'a')
        data = self.request.recv(1024)
        datas = data.split(' ')
        if len(datas) < 3:
            output.write('ERROR_1\n')# Length of request is wrong
            return
        if datas[0] != 'GET':
            output.write('ERROR_2\n')# Requset must be GET
            return
        if len(datas[1].split('/')) != 2:
            output.write('ERROR_3\n')#  Length of path is wrong
            return
        app = datas[1].split('/')[0]
        input_data = datas[1].split('/')[1]
        if app != STR_APP_ID:
            output.write('ERROR_4\n')# Had been forwarded to wrong application
            return
        output.write('done\n')
        output.close()
        MESSAGE = 'POST {}/{} HTTP/1.0\n<Headers>\n\nappId:{} serverId:{} value:{}\0'.format(app, input_data, APP_ID, SERVER_ID, input_data)
        self.request.send(MESSAGE)
        return

    def finish(self):
        return SocketServer.BaseRequestHandler.finish(self)

class myServer(SocketServer.TCPServer):
    
    def __init__(self, server_address, handler_class=myRequestHandler):
        print('Server start on {} for {}'.format(server_address, STR_APP_ID))
        SocketServer.TCPServer.__init__(self, server_address, handler_class)
        return

    def server_activate(self):
        SocketServer.TCPServer.server_activate(self)
        return

    def serve_forever(self):
        while True:
            self.handle_request()
        return

    def handle_request(self):
        return SocketServer.TCPServer.handle_request(self)

    def verify_request(self, request, client_address):
        return SocketServer.TCPServer.verify_request(self, request, client_address)

    def process_request(self, request, client_address):
        return SocketServer.TCPServer.process_request(self, request, client_address)

    def server_close(self):
        return SocketServer.TCPServer.server_close(self)

    def finish_request(self, request, client_address):
        return SocketServer.TCPServer.finish_request(self, request, client_address)

    def close_request(self, request_address):
        return SocketServer.TCPServer.close_request(self, request_address)

try:
    address = ('localhost', PORT_NUMBER)
    server = myServer(address, myRequestHandler)
    ip, port = server.server_address
    server.serve_forever()
except KeyboardInterrupt:
    print('Server 1270.0.1:{} shutdowned'.format(PORT_NUMBER))
    server.socket.close()
    server.server_close()